local libmg = LibStub("LibMouseGestures-1.0");
local doodle = libmg:New(UIParent);
local colors = {
	{1,0,0,1},
	{0,1,0,1},
	{0,0,1,1},
	{1,1,0,1},
	{1,0,1,1},
	{0,1,1,1}
}
local color = colors[1];
local colorx = 1;
local nodoodling = true;
local doodles, cdoodle, texs, free = {},{},{},{};


function Doodle_DrawLine(rec, T, sx, sy, ex, ey)
    sy = -sy;
    ey = -ey;
	local C = rec.drawLayer;
    w = 72;
    local dx,dy = ex - sx, ey - sy;
    local cx,cy = (sx + ex) / 2, (sy + ey) / 2;
    if (dx < 0) then
        dx,dy = -dx,-dy;
    end
    local Z = (256/255) / 2;
    local l = sqrt((dx * dx) + (dy * dy));
    local s,c = -dy / l, dx / l;
    local sc = s * c;
    local Bwid, Bhgt, BLx, BLy, TLx, TLy, TRx, TRy, BRx, BRy;
    if (dy >= 0) then
        Bwid = ((l * c) - (w * s)) * Z;
        Bhgt = ((w * c) - (l * s)) * Z;
        BLx, BLy, BRy = (w / l) * sc, s * s, (l / w) * sc;
        BRx, TLx, TLy, TRx = 1 - BLy, BLy, 1 - BRy, 1 - BLx;
        TRy = BRx;
    else
        Bwid = ((l * c) + (w * s)) * Z;
        Bhgt = ((w * c) + (l * s)) * Z;
        BLx, BLy, BRx = s * s, -(l / w) * sc, 1 + (w / l) * sc;
        BRy, TLx, TLy, TRy = BLx, 1 - BRx, 1 - BLx, 1 - BLy;
        TRx = TLy;
    end
    T:SetDrawLayer(layer or "OVERLAY")
    T:SetVertexColor(color[1],color[2],color[3],color[4]);
    T:SetTexCoord(TLx, TLy, BLx, BLy, TRx, TRy, BRx, BRy);
    T:SetPoint("TOPLEFT",   C, "TOPLEFT", cx - Bwid, cy + Bhgt);
    T:SetWidth(Bwid*2);
    T:SetHeight(Bhgt*2);
    T:Show()
end



function Doodle_Update(rec,a,b,c,d)
	if ( #cdoodle > 0 ) then
		local l = cdoodle[#cdoodle];
		if ( math.floor(l[1]) ~= math.floor(c) or math.floor(l[2]) ~= math.floor(d) ) then
			if ( abs( l[1] - c) < 1 and abs(l[2] - d) < 1 ) then -- lines that don't go anywhere makes me a sad panda.
				return;
			end
			table.insert(cdoodle, {c,d});
		end
	else
		table.insert(cdoodle, {c,d});
	end
	Doodle_Draw(rec);
end

function Doodle_Color()
	if ( IsShiftKeyDown() ) then
		colorx = colorx + 1;
		if ( colorx > #colors ) then colorx = 1; end
		color = colors[colorx];
	end
end

function Doodle_Stop(rec)
	table.insert(doodles, cdoodle);
	cdoodle = {};
	rec:StartCapture({
		startButton		= "LeftButtonDown",
		stopButton		= "LeftButtonUp",
		cancelButton    = "RightButtonUp",
		startFunc 		= Doodle_Color,
		updateFunc		= Doodle_Update,
		stopFunc 		= Doodle_Stop,
		cancelFunc		= Doodle_Cancel,
	});
end

function Doodle_Cancel(rec)
	Doodle_Draw(rec, true);
	if ( #doodles > 0 ) then
		rec:StartCapture({
			startButton		= "LeftButtonDown",
			stopButton		= "LeftButtonUp",
			cancelButton    = "RightButtonUp",
			startFunc 		= Doodle_Color,
			updateFunc		= Doodle_Update,
			stopFunc 		= Doodle_Stop,
			cancelFunc		= Doodle_Cancel,
		});
	else
		nodoodling = true;
		print("Exited doodle mode.");
	end
	doodles = {};
	cdoodle = {};
end

function Doodle_Draw(rec, wipe)
	if ( wipe == true ) then
		for n = 1, #texs do
			texs[n]:Hide();
			texs[n]:SetTexCoord(0,1,0,1);
			table.insert(free, texs[n]);
		end
		texs = {};
	else
		for n = 1, #cdoodle do
			if ( not cdoodle[n][3] and cdoodle[n-1] ) then
				local T = table.remove(free) or rec.drawLayer:CreateTexture();
				T:SetTexture([[Interface\AddOns\Doodle\line]]);
				cdoodle[n][3] = T;
				table.insert(texs, T);
				Doodle_DrawLine(rec, T, cdoodle[n-1][1], cdoodle[n-1][2], cdoodle[n][1], cdoodle[n][2]);
				T:Show();
			end
		end
	end
end


do
doodle.drawLayer:Hide();
    _G.SLASH_DOODLE1 = '/doodle';
	SlashCmdList['DOODLE'] = function()
		if ( doodle.drawLayer:IsVisible() ) then
			doodle.drawLayer:Hide()
		else
			if ( nodoodling == true ) then
				print("You are now in doodle mode. Use right click to wipe the screen and double right click to exit doodle mode.");
				nodoodling = false;
			doodle:StartCapture({
				startButton		= "LeftButtonDown",
				stopButton		= "LeftButtonUp",
				cancelButton    = "RightButtonUp",
				startFunc 		= Doodle_Color,
				updateFunc		= Doodle_Update,
				stopFunc 		= Doodle_Stop,
				cancelFunc		= Doodle_Cancel,
			});
			end
			doodle.drawLayer:Show();
		end
	end
end
